
#ifndef __SRC_CABLE_CABLECHANNEL_H__
#define __SRC_CABLE_CABLECHANNEL_H__

#include <glib.h>
#include <glib-object.h>
#include <gst/gst.h>
#include <stdlib.h>
#include <string.h>
#include "src/Channel.h"
#include "src/MpegTsEnums.h"

G_BEGIN_DECLS


#define DVB_TYPE_CABLE_CHANNEL (dvb_cable_channel_get_type ())
#define DVB_CABLE_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CABLE_CHANNEL, DVBCableChannel))
#define DVB_CABLE_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CABLE_CHANNEL, DVBCableChannelClass))
#define DVB_IS_CABLE_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CABLE_CHANNEL))
#define DVB_IS_CABLE_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CABLE_CHANNEL))
#define DVB_CABLE_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CABLE_CHANNEL, DVBCableChannelClass))

typedef struct _DVBCableChannel DVBCableChannel;
typedef struct _DVBCableChannelClass DVBCableChannelClass;
typedef struct _DVBCableChannelPrivate DVBCableChannelPrivate;

struct _DVBCableChannel {
	DVBChannel parent_instance;
	DVBCableChannelPrivate * priv;
};

struct _DVBCableChannelClass {
	DVBChannelClass parent_class;
};


DVBCableChannel* dvb_cable_channel_construct (GType object_type);
DVBCableChannel* dvb_cable_channel_new (void);
DVBDvbSrcInversion dvb_cable_channel_get_Inversion (DVBCableChannel* self);
void dvb_cable_channel_set_Inversion (DVBCableChannel* self, DVBDvbSrcInversion value);
guint dvb_cable_channel_get_SymbolRate (DVBCableChannel* self);
void dvb_cable_channel_set_SymbolRate (DVBCableChannel* self, guint value);
DVBDvbSrcCodeRate dvb_cable_channel_get_CodeRate (DVBCableChannel* self);
void dvb_cable_channel_set_CodeRate (DVBCableChannel* self, DVBDvbSrcCodeRate value);
DVBDvbSrcModulation dvb_cable_channel_get_Modulation (DVBCableChannel* self);
void dvb_cable_channel_set_Modulation (DVBCableChannel* self, DVBDvbSrcModulation value);
GType dvb_cable_channel_get_type (void);


G_END_DECLS

#endif
