
#ifndef __SRC_CHANNELLISTREADER_H__
#define __SRC_CHANNELLISTREADER_H__

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "src/Device.h"
#include "src/ChannelList.h"

G_BEGIN_DECLS


#define DVB_TYPE_CHANNEL_LIST_READER (dvb_channel_list_reader_get_type ())
#define DVB_CHANNEL_LIST_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_LIST_READER, DVBChannelListReader))
#define DVB_CHANNEL_LIST_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_LIST_READER, DVBChannelListReaderClass))
#define DVB_IS_CHANNEL_LIST_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_LIST_READER))
#define DVB_IS_CHANNEL_LIST_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_LIST_READER))
#define DVB_CHANNEL_LIST_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_LIST_READER, DVBChannelListReaderClass))

typedef struct _DVBChannelListReader DVBChannelListReader;
typedef struct _DVBChannelListReaderClass DVBChannelListReaderClass;
typedef struct _DVBChannelListReaderPrivate DVBChannelListReaderPrivate;

struct _DVBChannelListReader {
	GObject parent_instance;
	DVBChannelListReaderPrivate * priv;
};

struct _DVBChannelListReaderClass {
	GObjectClass parent_class;
};


DVBChannelListReader* dvb_channel_list_reader_construct (GType object_type, GFile* file, DVBAdapterType type);
DVBChannelListReader* dvb_channel_list_reader_new (GFile* file, DVBAdapterType type);
DVBChannelList* dvb_channel_list_reader_read (DVBChannelListReader* self, GError** error);
GFile* dvb_channel_list_reader_get_ChannelFile (DVBChannelListReader* self);
DVBAdapterType dvb_channel_list_reader_get_Type (DVBChannelListReader* self);
GType dvb_channel_list_reader_get_type (void);


G_END_DECLS

#endif
