
#include <src/IDBusSchedule.h>
#include <dbus/dbus-glib.h>




static gboolean _dbus_dvb_id_bus_schedule_GetAllEvents (DVBIDBusSchedule* self, GArray** dbus_result, GError** error);
static gboolean _dbus_dvb_id_bus_schedule_NowPlaying (DVBIDBusSchedule* self, guint32* result, GError** error);
static gboolean _dbus_dvb_id_bus_schedule_Next (DVBIDBusSchedule* self, guint32 event_id, guint32* result, GError** error);
static gboolean _dbus_dvb_id_bus_schedule_GetName (DVBIDBusSchedule* self, guint32 event_id, char** result, GError** error);
static gboolean _dbus_dvb_id_bus_schedule_GetShortDescription (DVBIDBusSchedule* self, guint32 event_id, char** result, GError** error);
static gboolean _dbus_dvb_id_bus_schedule_GetExtendedDescription (DVBIDBusSchedule* self, guint32 event_id, char** result, GError** error);
static gboolean _dbus_dvb_id_bus_schedule_GetDuration (DVBIDBusSchedule* self, guint32 event_id, guint* result, GError** error);
static gboolean _dbus_dvb_id_bus_schedule_GetLocalStartTime (DVBIDBusSchedule* self, guint32 event_id, GArray** dbus_result, GError** error);
static gboolean _dbus_dvb_id_bus_schedule_IsRunning (DVBIDBusSchedule* self, guint32 event_id, gboolean* result, GError** error);
static gboolean _dbus_dvb_id_bus_schedule_IsScrambled (DVBIDBusSchedule* self, guint32 event_id, gboolean* result, GError** error);


static void g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

guint32* dvb_id_bus_schedule_GetAllEvents (DVBIDBusSchedule* self, int* result_length1) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->GetAllEvents (self, result_length1);
}


/**
         * @returns: ID of currently running event
         */
guint32 dvb_id_bus_schedule_NowPlaying (DVBIDBusSchedule* self) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->NowPlaying (self);
}


/**
         * @returnns: ID of event that follows the given event
         */
guint32 dvb_id_bus_schedule_Next (DVBIDBusSchedule* self, guint32 event_id) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->Next (self, event_id);
}


char* dvb_id_bus_schedule_GetName (DVBIDBusSchedule* self, guint32 event_id) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->GetName (self, event_id);
}


char* dvb_id_bus_schedule_GetShortDescription (DVBIDBusSchedule* self, guint32 event_id) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->GetShortDescription (self, event_id);
}


char* dvb_id_bus_schedule_GetExtendedDescription (DVBIDBusSchedule* self, guint32 event_id) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->GetExtendedDescription (self, event_id);
}


guint dvb_id_bus_schedule_GetDuration (DVBIDBusSchedule* self, guint32 event_id) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->GetDuration (self, event_id);
}


guint* dvb_id_bus_schedule_GetLocalStartTime (DVBIDBusSchedule* self, guint32 event_id, int* result_length1) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->GetLocalStartTime (self, event_id, result_length1);
}


gboolean dvb_id_bus_schedule_IsRunning (DVBIDBusSchedule* self, guint32 event_id) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->IsRunning (self, event_id);
}


gboolean dvb_id_bus_schedule_IsScrambled (DVBIDBusSchedule* self, guint32 event_id) {
	return DVB_ID_BUS_SCHEDULE_GET_INTERFACE (self)->IsScrambled (self, event_id);
}


static gboolean _dbus_dvb_id_bus_schedule_GetAllEvents (DVBIDBusSchedule* self, GArray** dbus_result, GError** error) {
	guint32* result;
	int result_length1;
	result = dvb_id_bus_schedule_GetAllEvents (self, &result_length1);
	(*dbus_result) = g_array_new (TRUE, TRUE, sizeof (guint32));
	g_array_append_vals ((*dbus_result), result, result_length1);
	return !error || !*error;
}


static gboolean _dbus_dvb_id_bus_schedule_NowPlaying (DVBIDBusSchedule* self, guint32* result, GError** error) {
	*result = dvb_id_bus_schedule_NowPlaying (self);
	return !error || !*error;
}


static gboolean _dbus_dvb_id_bus_schedule_Next (DVBIDBusSchedule* self, guint32 event_id, guint32* result, GError** error) {
	*result = dvb_id_bus_schedule_Next (self, event_id);
	return !error || !*error;
}


static gboolean _dbus_dvb_id_bus_schedule_GetName (DVBIDBusSchedule* self, guint32 event_id, char** result, GError** error) {
	*result = dvb_id_bus_schedule_GetName (self, event_id);
	return !error || !*error;
}


static gboolean _dbus_dvb_id_bus_schedule_GetShortDescription (DVBIDBusSchedule* self, guint32 event_id, char** result, GError** error) {
	*result = dvb_id_bus_schedule_GetShortDescription (self, event_id);
	return !error || !*error;
}


static gboolean _dbus_dvb_id_bus_schedule_GetExtendedDescription (DVBIDBusSchedule* self, guint32 event_id, char** result, GError** error) {
	*result = dvb_id_bus_schedule_GetExtendedDescription (self, event_id);
	return !error || !*error;
}


static gboolean _dbus_dvb_id_bus_schedule_GetDuration (DVBIDBusSchedule* self, guint32 event_id, guint* result, GError** error) {
	*result = dvb_id_bus_schedule_GetDuration (self, event_id);
	return !error || !*error;
}


static gboolean _dbus_dvb_id_bus_schedule_GetLocalStartTime (DVBIDBusSchedule* self, guint32 event_id, GArray** dbus_result, GError** error) {
	guint* result;
	int result_length1;
	result = dvb_id_bus_schedule_GetLocalStartTime (self, event_id, &result_length1);
	(*dbus_result) = g_array_new (TRUE, TRUE, sizeof (guint));
	g_array_append_vals ((*dbus_result), result, result_length1);
	return !error || !*error;
}


static gboolean _dbus_dvb_id_bus_schedule_IsRunning (DVBIDBusSchedule* self, guint32 event_id, gboolean* result, GError** error) {
	*result = dvb_id_bus_schedule_IsRunning (self, event_id);
	return !error || !*error;
}


static gboolean _dbus_dvb_id_bus_schedule_IsScrambled (DVBIDBusSchedule* self, guint32 event_id, gboolean* result, GError** error) {
	*result = dvb_id_bus_schedule_IsScrambled (self, event_id);
	return !error || !*error;
}


static void dvb_id_bus_schedule_base_init (DVBIDBusScheduleIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		static const DBusGMethodInfo dvb_id_bus_schedule_dbus_methods[] = {
{ (GCallback) _dbus_dvb_id_bus_schedule_GetAllEvents, g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER, 0 },
{ (GCallback) _dbus_dvb_id_bus_schedule_NowPlaying, g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER, 55 },
{ (GCallback) _dbus_dvb_id_bus_schedule_Next, g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER, 107 },
{ (GCallback) _dbus_dvb_id_bus_schedule_GetName, g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER, 166 },
{ (GCallback) _dbus_dvb_id_bus_schedule_GetShortDescription, g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER, 228 },
{ (GCallback) _dbus_dvb_id_bus_schedule_GetExtendedDescription, g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER, 302 },
{ (GCallback) _dbus_dvb_id_bus_schedule_GetDuration, g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER, 379 },
{ (GCallback) _dbus_dvb_id_bus_schedule_GetLocalStartTime, g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER, 445 },
{ (GCallback) _dbus_dvb_id_bus_schedule_IsRunning, g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER, 518 },
{ (GCallback) _dbus_dvb_id_bus_schedule_IsScrambled, g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER, 582 },
}
;
		static const DBusGObjectInfo dvb_id_bus_schedule_dbus_object_info = { 0, dvb_id_bus_schedule_dbus_methods, 10, "org.gnome.DVB.Schedule\0GetAllEvents\0S\0result\0O\0F\0N\0au\0\0org.gnome.DVB.Schedule\0NowPlaying\0S\0result\0O\0F\0N\0u\0\0org.gnome.DVB.Schedule\0Next\0S\0event_id\0I\0u\0result\0O\0F\0N\0u\0\0org.gnome.DVB.Schedule\0GetName\0S\0event_id\0I\0u\0result\0O\0F\0N\0s\0\0org.gnome.DVB.Schedule\0GetShortDescription\0S\0event_id\0I\0u\0result\0O\0F\0N\0s\0\0org.gnome.DVB.Schedule\0GetExtendedDescription\0S\0event_id\0I\0u\0result\0O\0F\0N\0s\0\0org.gnome.DVB.Schedule\0GetDuration\0S\0event_id\0I\0u\0result\0O\0F\0N\0u\0\0org.gnome.DVB.Schedule\0GetLocalStartTime\0S\0event_id\0I\0u\0result\0O\0F\0N\0au\0\0org.gnome.DVB.Schedule\0IsRunning\0S\0event_id\0I\0u\0result\0O\0F\0N\0b\0\0org.gnome.DVB.Schedule\0IsScrambled\0S\0event_id\0I\0u\0result\0O\0F\0N\0b\0\0", "", "" };
		dbus_g_object_type_install_info (DVB_TYPE_ID_BUS_SCHEDULE, &dvb_id_bus_schedule_dbus_object_info);
	}
}


GType dvb_id_bus_schedule_get_type (void) {
	static GType dvb_id_bus_schedule_type_id = 0;
	if (dvb_id_bus_schedule_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (DVBIDBusScheduleIface), (GBaseInitFunc) dvb_id_bus_schedule_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		dvb_id_bus_schedule_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBIDBusSchedule", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (dvb_id_bus_schedule_type_id, G_TYPE_OBJECT);
	}
	return dvb_id_bus_schedule_type_id;
}



static void g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef gboolean (*GMarshalFunc_BOOLEAN__POINTER_POINTER) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_BOOLEAN__POINTER_POINTER callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	gboolean v_return;
	cc = ((GCClosure *) (closure));
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = ((GMarshalFunc_BOOLEAN__POINTER_POINTER) ((marshal_data ? marshal_data : cc->callback)));
	v_return = callback (data1, g_value_get_pointer (param_values + 1), g_value_get_pointer (param_values + 2), data2);
	g_value_set_boolean (return_value, v_return);
}


static void g_cclosure_user_marshal_BOOLEAN__UINT_POINTER_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef gboolean (*GMarshalFunc_BOOLEAN__UINT_POINTER_POINTER) (gpointer data1, guint32 arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_BOOLEAN__UINT_POINTER_POINTER callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	gboolean v_return;
	cc = ((GCClosure *) (closure));
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = ((GMarshalFunc_BOOLEAN__UINT_POINTER_POINTER) ((marshal_data ? marshal_data : cc->callback)));
	v_return = callback (data1, g_value_get_uint (param_values + 1), g_value_get_pointer (param_values + 2), g_value_get_pointer (param_values + 3), data2);
	g_value_set_boolean (return_value, v_return);
}



